LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY dpll IS

	PORT
	(
		b_clk		: IN	STD_LOGIC;
		irin		: IN	STD_LOGIC;
		reset		: IN	STD_LOGIC;
		shift_p		: OUT	STD_LOGIC
	);
	
END dpll;

ARCHITECTURE RTL OF dpll IS

	SIGNAL	divider	: INTEGER RANGE 0 TO 419;
	SIGNAL	cnt32	: INTEGER RANGE 0 TO 31;
	SIGNAL	delay_irin	: std_logic_vector(0 to 1);
	SIGNAL  cin		:std_logic;
	
BEGIN
	PROCESS (divider,cnt32)
	BEGIN
	if divider = 419 then
		cin <= '1';
	else
		cin <= '0';
	end if;
	if ((cnt32 = 4 OR cnt32 =18) AND cin ='1') then
		shift_p <= '1';
	else
		shift_p <= '0';
	end if;
	END PROCESS;

	PROCESS (b_clk,reset)
	BEGIN
	if reset = '1' then
		delay_irin <= "00";
		cnt32 <= 0;
	else
	 IF (b_clk'EVENT AND b_clk = '1') THEN
		if divider = 419 then
			divider <= 0;
		else
			divider <= divider + 1;
		end if;
		if cin = '1' then
			delay_irin(0) <= irin;
			delay_irin(1) <=delay_irin(0);			
			IF (delay_irin = "10") THEN					
				cnt32 <= 0;					
			ELSE
				cnt32 <= cnt32 +1;			
			END IF;
		end if;
	 ELSE
		delay_irin <= delay_irin;
		divider <= divider;
		cnt32 <= cnt32;		
	 END IF;
	end if;
	END PROCESS;
END RTL;
